﻿package implement

import (
	"code.fnuoos.com/EggPlanet/egg_models.git/src/dao"
	"code.fnuoos.com/EggPlanet/egg_models.git/src/model"
	zhios_order_relate_logx "code.fnuoos.com/EggPlanet/egg_models.git/utils/logx"
	"fmt"
	"xorm.io/xorm"
)

func NewUserTagRecordsDb(engine *xorm.Engine) dao.UserTagRecordsDao {
	return &UserTagRecordsDb{Db: engine}
}

type UserTagRecordsDb struct {
	Db *xorm.Engine
}

func (u UserTagRecordsDb) UserTagRecordsGetOneByParams(params map[string]interface{}) (*model.UserTagRecords, error) {
	var m model.UserTagRecords
	var query = fmt.Sprintf("%s = ?", params["key"])
	if has, err := u.Db.Where(query, params["value"]).Get(&m); err != nil || has == false {
		return nil, zhios_order_relate_logx.Error(err)
	}
	return &m, nil
}

func (u UserTagRecordsDb) UserTagRecordsUpdate(uid interface{}, user *model.UserTagRecords, forceColumns ...string) (int64, error) {
	var (
		affected int64
		err      error
	)
	if forceColumns != nil {
		affected, err = u.Db.Where("uid=?", uid).Cols(forceColumns...).Update(user)
	} else {
		affected, err = u.Db.Where("uid=?", uid).Update(user)
	}
	if err != nil {
		return 0, err
	}
	return affected, nil
}
